

#include "uart.h"


void uart_tx_init(void)
{
	//Configure GPIOD PD8 as TX pin
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIODEN;
	GPIOD->MODER|=GPIO_MODER_MODER8_1;
	#define AF07 0x07

	GPIOD->AFR[1]|=(AF07<<0);
	//Configure the UART
	RCC->APB1ENR|=RCC_APB1ENR_USART3EN;
	USART3->BRR    = 0x008B; // baud rate 115200 @16MHz
	USART3->CR1|=USART_CR1_TE; //enbale TX
	USART3->CR1|=USART_CR1_UE;

}


void uart_write( char c)
{
	/*Make sure transmit data register is empty*/
	while(!((USART3->ISR & USART_ISR_TXE)== USART_ISR_TXE)){}

	/*Write value into transmit data register*/
	USART3->TDR = c;
}

int __io_putchar(int ch)
{
	uart_write(ch);

	return ch;
}

